﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.Misc;
using Infragistics.Win;
using Infragistics.Win.UltraWinToolTip;

namespace WinValidatorImagination
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraValidator1.SetValidationSettings(
     this.ultraTextEditor1,
     this.CreateOperatorCondition(this.ultraTextEditor1));

            this.ultraValidator1.SetValidationSettings(
                this.ultraNumericEditor1,
                this.CreateRangeCondition(this.ultraNumericEditor1));

            
        }

        private void button1_Click(object sender, EventArgs e)
        {
            
        }


        private ValidationSettings CreateOperatorCondition(Control theControl)
        {
            ValidationSettings thePasswordSettings =
                this.ultraValidator1.GetValidationSettings(theControl);

            thePasswordSettings.Condition =
                new OperatorCondition(ConditionOperator.Match, "^[a-z,A-Z,1-9]{8,20}$");

            thePasswordSettings.DataType = typeof(string);

            return thePasswordSettings;
        }

        private ValidationSettings CreateRangeCondition(Control theControl)
        {
            ValidationSettings theRGBSettings =
                this.ultraValidator1.GetValidationSettings(theControl);

            theRGBSettings.Condition =
                new RangeCondition(0, 255, typeof(int));

            return theRGBSettings;
        }

        private void ultraValidator1_ValidationError(object sender, ValidationErrorEventArgs e)
        {
            switch (e.Control.Name)
            {
                case "ultraTextEditor1":
                    e.NotificationSettings.Action =
                        NotificationAction.Image;
                    e.NotificationSettings.Text =
                        "Password must by 8-20 characters long";
                    UltraToolTipInfo toolTipInfo = ultraToolTipManager1.GetUltraToolTip(e.Control);
                    toolTipInfo.ToolTipText = "Password must by 8-20 characters long";
                    toolTipInfo.ToolTipTitle = "Error";
                    Point p = e.Control.PointToScreen(e.Control.Location);
                    ultraToolTipManager1.ShowToolTip(e.Control,
                        new Point(p.X + e.Control.Width - 13,
                            p.Y + e.Control.Height - 32));

                    break;

                case "ultraNumericEditor1":
                    RangeCondition theRangeCondition =
                        e.Validation.Errors[0].ValidationSettings.Condition as
                        RangeCondition;

                    e.NotificationSettings.Action =
                        NotificationAction.MessageBox;

                    StringBuilder theString = new StringBuilder(String.Empty);

                    theString.Append("The value ");
                    theString.Append(e.Validation.Errors[0].Value);
                    theString.Append(" is invalid. Please select a value between ");
                    theString.Append(theRangeCondition.MinimumValue);
                    theString.Append(" and ");
                    theString.Append(theRangeCondition.MaximumValue);

                    e.NotificationSettings.Text = theString.ToString();

                    break;
            }
        }

        private void ultraTextEditor1_Leave(object sender, EventArgs e)
        {
            this.ultraValidator1.Validate(ultraTextEditor1);
           
        }

        private void ultraNumericEditor1_Leave(object sender, EventArgs e)
        {
            this.ultraValidator1.Validate(ultraNumericEditor1);
        }



    }
}
